/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package game;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.*;

/**
 * @author viktorzhs
 */
public class Board extends javax.swing.JFrame {

    /**
     * Creates new form Board
     */
    public Board() {
        initComponents();
        buttons = new ArrayList<>(
                List.of(
                        Button11, Button12, Button13,
                        Button21, Button22, Button23,
                        Button31, Button32, Button33
                )
        );
        rand = new Random();
        move = 0;
        result = "Win";
        res = new ResultScreen();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        Button11 = new javax.swing.JButton();
        Button13 = new javax.swing.JButton();
        Button12 = new javax.swing.JButton();
        Button21 = new javax.swing.JButton();
        Button22 = new javax.swing.JButton();
        Button23 = new javax.swing.JButton();
        Button31 = new javax.swing.JButton();
        Button32 = new javax.swing.JButton();
        Button33 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel2.setBackground(new java.awt.Color(153, 204, 255));

        jPanel1.setBackground(new java.awt.Color(153, 153, 255));
        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        Button11.setBackground(new java.awt.Color(204, 204, 255));
        Button11.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button11.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button11MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        Button13.setBackground(new java.awt.Color(204, 204, 255));
        Button13.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button13.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button13MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        Button12.setBackground(new java.awt.Color(204, 204, 255));
        Button12.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button12.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button12MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        Button21.setBackground(new java.awt.Color(204, 204, 255));
        Button21.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button21.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button21MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        Button22.setBackground(new java.awt.Color(204, 204, 255));
        Button22.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button22.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button22MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        Button23.setBackground(new java.awt.Color(204, 204, 255));
        Button23.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button23.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button23MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        Button31.setBackground(new java.awt.Color(204, 204, 255));
        Button31.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button31.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button31MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        Button32.setBackground(new java.awt.Color(204, 204, 255));
        Button32.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button32.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button32MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        Button33.setBackground(new java.awt.Color(204, 204, 255));
        Button33.setFont(new java.awt.Font("Segoe UI", 0, 36)); // NOI18N
        Button33.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                try {
                    Button33MouseClicked(evt);
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(20, 20, 20)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addComponent(Button31, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(Button32, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addComponent(Button21, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(Button22, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addComponent(Button11, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(Button12, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(Button33, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(Button23, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(Button13, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addContainerGap(19, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(16, 16, 16)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(Button11, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(Button13, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(Button12, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(Button21, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(Button23, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(Button22, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(Button31, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(Button33, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(Button32, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addContainerGap(20, Short.MAX_VALUE))
        );

        jLabel1.setFont(new java.awt.Font("Segoe UI", 1, 24)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Players");

        jLabel2.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("You: o (first to play)");

        jLabel3.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        jLabel3.setForeground(new java.awt.Color(255, 255, 255));
        jLabel3.setText("Computer: x");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
                jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel2Layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 36, Short.MAX_VALUE)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel1)
                                                .addGap(45, 45, 45))
                                        .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel3)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                                .addGap(22, 22, 22))
        );
        jPanel2Layout.setVerticalGroup(
                jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addContainerGap()
                                                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addGap(119, 119, 119)
                                                .addComponent(jLabel1)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(jLabel2)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(jLabel3)))
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void Button11MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button11MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button11)) {
            Button11.setText("o");
            incrementMove();
            playComputer();
        }
    }//GEN-LAST:event_Button11MouseClicked

    private void Button12MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button12MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button12)) {
            Button12.setText("o");
            incrementMove();
            playComputer();
        }
    }//GEN-LAST:event_Button12MouseClicked

    private void Button13MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button13MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button13)) {
            Button13.setText("o");
            incrementMove();
            playComputer();
        }
    }//GEN-LAST:event_Button13MouseClicked

    private void Button21MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button21MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button21)) {
            Button21.setText("o");
            incrementMove();
            playComputer();
        }
    }//GEN-LAST:event_Button21MouseClicked

    private void Button22MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button22MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button22)) {
            Button22.setText("o");
            incrementMove();
            playComputer();
        }
    }//GEN-LAST:event_Button22MouseClicked

    private void Button23MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button23MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button23)) {
            Button23.setText("o");
            incrementMove();
            playComputer();
        }
    }//GEN-LAST:event_Button23MouseClicked

    private void Button31MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button31MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button31)) {
            Button31.setText("o");
            incrementMove();
            playComputer();
        }
    }//GEN-LAST:event_Button31MouseClicked

    private void Button32MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button32MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button32)) {
            Button32.setText("o");
            incrementMove();
            playComputer();
        }
    }//GEN-LAST:event_Button32MouseClicked

    private void Button33MouseClicked(java.awt.event.MouseEvent evt) throws IOException {//GEN-FIRST:event_Button33MouseClicked
        // TODO add your handling code here:
        if (isButtonFree(Button33)) {
            Button33.setText("o");
            incrementMove();
            playComputer();
        }

    }//GEN-LAST:event_Button33MouseClicked

    private boolean isButtonFree(javax.swing.JButton button) {
        return "".equals(button.getText());
    }

    private void incrementMove() {
        move++;
    }

    private boolean isMoveFinal() {
        return move == 9;
    }

    private boolean canGameBeWon() {
        return move >= 5;
    }

    private void playComputer() throws IOException {
        if (!isGameWon()) {
            System.out.println("Current move: " + move);
            if (!isMoveFinal()) {
                int desiredField = rand.nextInt((9 - 1) + 1) + 1;
                while (!isButtonFree(buttons.get(desiredField - 1))) {
                    desiredField = rand.nextInt((9 - 1) + 1) + 1;
                }
                buttons.get(desiredField - 1).setText("x");
                incrementMove();
                if (isGameWon()) {
                    dispose();
                    res.setResult(result);
                    res.setVisible(true);
                }
            }
        } else {
            dispose();
            res.setResult(result);
            res.setVisible(true);
        }
    }

    private boolean horizontalWin(int startIndex, String player) {
        return buttons.get(startIndex).getText().equals(buttons.get(startIndex + 1).getText())
                && buttons.get(startIndex + 1).getText().equals(buttons.get(startIndex + 2).getText())
                && buttons.get(startIndex + 2).getText().equals(player);
    }

    /*
    0, 1, 2
    3, 4, 5
    6, 7, 8

     */

    private boolean verticalWin(int startIndex, String player) {
        return buttons.get(startIndex).getText().equals(buttons.get(startIndex + 3).getText())
                && buttons.get(startIndex + 3).getText().equals(buttons.get(startIndex + 6).getText())
                && buttons.get(startIndex + 6).getText().equals(player);
    }

    private boolean primeDiagonalWin(String player) {
        return buttons.get(0).getText().equals(buttons.get(4).getText())
                && buttons.get(4).getText().equals(buttons.get(8).getText())
                && buttons.get(8).getText().equals(player);
    }

    private boolean secondaryDiagonalWin(String player) {
        return buttons.get(2).getText().equals(buttons.get(4).getText())
                && buttons.get(4).getText().equals(buttons.get(6).getText())
                && buttons.get(6).getText().equals(player);
    }

    private void saveGameResult(String player) throws IOException {
        File file = new File("src/game/Users.txt");
        if (file == null) {
            throw new FileNotFoundException("404");
        }
        Path path = Path.of("src/game/Users.txt");
        if (player.equals("x")) {
            Files.write(path, "Loss\n".getBytes(), StandardOpenOption.APPEND);
        } else if (player.equals("o")) {
            Files.write(path, "Win\n" .getBytes(), StandardOpenOption.APPEND);
        }
        else {
            Files.write(path, "Draw\n".getBytes(), StandardOpenOption.APPEND);
        }
    }


    private boolean isGameWon() throws IOException {
        if (canGameBeWon()) {
            if (horizontalWin(0, "x") || horizontalWin(3, "x") || horizontalWin(6, "x")) {
                saveGameResult("x");
                result = "Loss";
                return true;
            } else if (horizontalWin(0, "o") || horizontalWin(3, "o") || horizontalWin(6, "o")) {
                saveGameResult("o");
                return true;
            } else if (verticalWin(0, "x") || verticalWin(1, "x") || verticalWin(2, "x")) {
                saveGameResult("x");
                result = "Loss";
                return true;
            } else if (verticalWin(0, "o") || verticalWin(1, "o") || verticalWin(2, "o")) {
                saveGameResult("o");
                return true;
            } else if (primeDiagonalWin("x")) {
                saveGameResult("x");
                result = "Loss";
                return true;
            } else if (primeDiagonalWin("o")) {
                saveGameResult("o");
                return true;
            } else if (secondaryDiagonalWin("x")) {
                saveGameResult("x");
                result = "Loss";
                return true;
            } else if (secondaryDiagonalWin("o")) {
                saveGameResult("o");
                return true;
            }
        }
        if (move == 9) {
            System.out.println("Draw");
            result = "Draw";
            dispose();
            res.setResult(result);
            res.setVisible(true);
            saveGameResult("");
            return false;
        }
        return false;
    }


    /**
     * @param args the command line arguments
     */


    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Board.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Board.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Board.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Board.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {


                new Board().setVisible(true);
            }
        });
    }

    private List<javax.swing.JButton> buttons;
    private Random rand;
    private int move;
    private String result;
    private ResultScreen res;

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Button11;
    private javax.swing.JButton Button12;
    private javax.swing.JButton Button13;
    private javax.swing.JButton Button21;
    private javax.swing.JButton Button22;
    private javax.swing.JButton Button23;
    private javax.swing.JButton Button31;
    private javax.swing.JButton Button32;
    private javax.swing.JButton Button33;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    // End of variables declaration//GEN-END:variables
}
